-- Flash Bulbs
-- Creates the effect of camera flashes going off

-- Define Properties
property("Foreground", COLOUR, 255,255,255)
property("Background", COLOUR, 0,0,0)
property("Seed", INTEGER, math.random(1,5000),0)
property("Max_Size", INTEGER, 15,0)
property("Min_Size", INTEGER, 5,0)
property("Max_Flash_Count", INTEGER, 5,0)
property("Rate",INTEGER,1,1,33)

-- Run at Initialisation
flashx={math.random(0, width)}
flashy={math.random(0, height)}
flashsize={math.random(Min_Size, Max_Size)}
for i=1,Max_Flash_Count do
    if math.random(0,1)==0 then
        flashx[#flashx+1] = math.random(0, width)
        flashy[#flashy+1] = math.random(0, height)
        flashsize[#flashsize+1] = math.random(Min_Size, Max_Size)
    end
end
lastFrame = -1

--Define Pixel function
function pixel(frame, x, y)
    out = Background
        if frame == lastFrame + Rate then
            lastFrame = frame
            flashx={math.random(0, width)}
            flashy={math.random(0, height)}
            flashsize={math.random(Min_Size, Max_Size)}
            for i=1,Max_Flash_Count do
                if math.random(0,1)==0 then
                    flashx[#flashx+1] = math.random(0, width)
                    flashy[#flashy+1] = math.random(0, height)
                    flashsize[#flashsize+1] = math.random(Min_Size, Max_Size)
                end
            end
        end
    for i=1, #flashx do
        if dist(flashx[i],flashy[i],x,y) < flashsize[i] then
            out = Foreground
        end
    end
    return out
end

--[[
Copyright 2016 Pharos Architectural Controls Limited. All rights reserved.

This sample content is made freely available for illustrative purposes only. Pharos Architectural Controls grants a non-exclusive copyright licence to use this sample content from which you can generate content tailored to your own specific needs for use with products from Pharos Architectural Controls. This sample content has not been thoroughly tested under all conditions and Pharos Architectural Controls cannot guarantee reliability or serviceability.

This sample content is provided "as is" without warranties of any kind. The implied warranties of non-infringement, merchantability and fitness for a particular purpose are expressly disclaimed. In no event shall Pharos Architectural Controls be liable to any party for direct, indirect, incidental or consequential damages arising from the use of this sample content.

For further information please contact support@pharoscontrols.com.
--]]